<template>
  <q-banner :class="`bg-negative text-white q-ma-${margin}`" rounded>
    <span v-if="errorObject">{{
      `${errorObject.status}: ${errorObject.message}`
    }}</span>
    <span v-else>Fail: Error happened</span>
  </q-banner>
</template>

<script>
import { extractErrorObject } from 'src/utils/helpers'

export default {
  name: 'ErrorBanner',
  props: {
    error: {
      type: Error,
    },
    margin: {
      type: String,
      validator: function(value) {
        return ['xs', 'sm', 'md', 'lg', 'xl'].indexOf(value) !== -1
      },
      default: 'xl',
    },
  },
  computed: {
    errorObject() {
      return this.error ? extractErrorObject(this.error) : null
    },
  },
}
</script>
